#include <SoftwareSerial.h>

SoftwareSerial EEBlue(10, 11); // RX | TX HC-05

int emicArduinoPin = 2; // Pin, an welchem der andere Arduino (mit dem Emic2-Modul) angeschlossen ist.


float MIN_ALLOWED_DISTANCE = 150; // min. Entfernung in cm - wenn die Menschen naeher sind, gibt es Ansage

void setup() {
  EEBlue.begin(9600); // TODO: evtl. die Baudrate anpassen
  Serial.begin(9600);  // Die drei Baudraten muessen nicht unbedingt gleich sein
  pinMode(emicArduinoPin, OUTPUT);

}

void loop() {

  // Feed any data from bluetooth to Terminal.
  if (EEBlue.available())
    Serial.write(EEBlue.read());
 
  // Feed all data from termial to bluetooth
  if (Serial.available())
    EEBlue.write(Serial.read());

  if (EEBlue.available()) {
    String receivedString = readStringFromPort(EEBlue, '\n'); // lese Daten bis zum Zeilenumbruch
    float distance = receivedString.toFloat();
    // Bei dieser Methode, wenn die Umwandlung nicht funktioniert hat, kommt 0 zurueck
    Serial.println(distance);

    if (distance != 0 && distance < MIN_ALLOWED_DISTANCE) {
      digitalWrite(emicArduinoPin, HIGH);
      delay(10); 
      digitalWrite(emicArduinoPin, LOW); 
    }

  }
}

// Liest Bytes, bis ein bestimmtes Zeichen (messageEnd) kommt,
// und setzt sie zu einem String zusammen
String readStringFromPort(SoftwareSerial &serialPort, char messageEnd) {
  String result = ""; // leerer String
  char currentCharacter = messageEnd + 1; // der Variable irgendeinen anderen Wert geben
  while (true) {
    currentCharacter = serialPort.read();
    if (currentCharacter == messageEnd) { // wenn wir ans End-Symbol (z.B. Zeilenumbruch) angekommen sind
      break; // die while-Schleife abbrechen
    } else {
      result = result + currentCharacter; // an den String anhaengen
    }
  }
  return result;
}
