// https://exploreembedded.com/wiki/Setting_up_Bluetooth_HC-05_with_Arduino

#include <Wire.h>
#include <LiquidCrystal_I2C.h>
#include <SoftwareSerial.h>

LiquidCrystal_I2C lcd(0x27, 20, 4); // set the LCD address to 0x27 for a 16 chars and 2 line display
int otherArduinoPin = 3; // can be any pin

void setup() { //Initialisierung des Emic2-Moduls
  // define pin modes
  pinMode(ledPin, OUTPUT);
  pinMode(rxPin, INPUT);
  pinMode(txPin, OUTPUT);
  
  // set the data rate for the SoftwareSerial port
  emicSerial.begin(9600);

  digitalWrite(ledPin, LOW);  // turn LED off
  
  /*
    When the Emic 2 powers on, it takes about 3 seconds for it to successfully
    intialize. It then sends a ":" character to indicate it's ready to accept
    commands. If the Emic 2 is already initialized, a CR will also cause it
    to send a ":"
  */
  emicSerial.print('\n');             // Send a CR in case the system is already up
  while (emicSerial.read() != ':');   // When the Emic 2 has initialized and is ready, it will send a single ':' character, so wait here until we receive it
  delay(10);                          // Short delay
  emicSerial.flush();                 // Flush the receive buffer
}

void loop() {

  if (digitalRead(otherArduinoPin) == HIGH) {
    lcd.clear(); // durch entsprechende EMIC-Ansage ersetzen
    digitalWrite(13, HIGH);
    lcd.print("You are too close!"); // durch entsprechende EMIC-Ansage ersetzen
    delay(2000); // Dauer aendern wie noetig
    digitalWrite(13, LOW);
  } else {
    lcd.clear();  // das wahrscheinlich loeschen
    lcd.print("OK");
  }

}
