let video;
let poseNet;

//Variablen um Punkte im Bild zu erfassen von Person 1 und Person 2 
let schulterLX1;
let schulterLY1;
let schulterRX1;
let huefteLX1;
let huefteLY1;
let schulterLX2;
let schulterLY2;
let schulterRX2;
let huefteLX2;
let huefteLY2;
//let schulterLX3;
//let schulterLY3;
//let huefteLX3;
//let huefteLY3;


let abstandHS1; //Abstand Huefte-Schulter Person 1
let abstandHS2; //Abstand Huefte-Schulter Person 2
//let abstandHS3; //Abstand Huefte-Schulter Person 3
let abstandK1; //Abstand Kamera Person 1 in cm
let abstandK2; //Abstand Kamera Person 2 in cm
//let abstandK3; //Abstand Kamera Person 3 in cm 

let abstand1; //Abstand Kamera Person 1 in Pixel
let abstand2; //Abstand Kamera Person 2 in Pixel
let winkel12; //Winkel zwischen Person 1 und 2 
let abstandE; //Abstand zwischen Person 1 und 2 in Pixel in X Ebene
let abstandD; //Differenz zwischen Person 1 und dem linken Bildschirmrand in Pixel
let abstandF; //Differenz zwischen Person 2 und dem rechten Bildschirmrand in Pixel
let c = 1000; //Bildschrimbreite in Pixel

let abstandFinal12;//Abstand zwischen Person 1 und 2
//let abstandFinal23; //Abstand zwischen Person 2 und 3
//let abstandFinal13; //Abstand zwischen Person 3 und 1


function setup() {
  createCanvas(1000, 680);
  video=createCapture (VIDEO);
  video.hide();
  poseNet = ml5.poseNet(video, modelReady);
  poseNet.on('pose',gotPoses);
  
  //p5 soll Winkel in Radian interpretieren
  angleMode(RADIANS);
}

function gotPoses (poses){
  console.log (poses);
  if(poses.length >1 ) {
  
  //Variablen x,y der Posen in die deklarierten Variablen schreiben
  huefteLX1 = poses[0].pose.keypoints[11].position.x;
  huefteLY1 = poses[0].pose.keypoints[11].position.y;
  schulterLX1 = poses[0].pose.keypoints[5].position.x;
  schulterLY1 = poses[0].pose.keypoints[5].position.y;
  schulterRX1 = poses[0].pose.keypoints[6].position.x;
  
  huefteLX2 = poses[1].pose.keypoints[11].position.x;
  huefteLY2 = poses[1].pose.keypoints[11].position.y;
  schulterLX2 = poses[1].pose.keypoints[5].position.x;
  schulterLY2 = poses[1].pose.keypoints[5].position.y;
  schulterRX2 = poses[1].pose.keypoints[6].position.x;

  /*huefteLX3 = poses[2].pose.keypoints[11].position.x;
  huefteLY3 = poses[2].pose.keypoints[11].position.y;
  schulterLX3 = poses[2].pose.keypoints[5].position.x;
  schulterLY3 = poses[2].pose.keypoints[5].position.y;*/

  
  
  /*Ausgabe der Koordinaten
  console.log('Koordinaten der linken Hüfte P1: x:'+huefteLX1+', y:'+huefteLY1);
  console.log('Koordinaten der linken Schulter P1: x:'+schulterLX1+', y:'+schulterLY1);
  console.log('Koordinaten der linken Hüfte P2: x:'+huefteLX2+', y:'+huefteLY2);
  console.log('Koordinaten der linken Schulter P2: x:'+schulterLX2+', y:'+schulterLY2);*/
  
  //Pixelanzahl zwischen Schulter und Huefte bestimmen (bei 2 m Abstand)
    //y2-y1 (Abstand vertikal)
  abstandHS1 = huefteLY1-schulterLY1;
  abstandHS2 = huefteLY2-schulterLY2;
  //abstandHS3 = huefteLY3-schulterLY3;
  
  /*Ausgabe der Pixelanzahl
  console.log('Pixelanzahl zwischen Huefte und Schulter P1: '+abstandHS1);
  console.log('Pixelanzahl zwischen Huefte und Schulter P2: '+abstandHS2);
  //die durchschnittliche Anzahl beträgt 127 Pixel auf 200 cm (bei einem Abstand von ca. 46 cm)*/
  
  //mit dem antiproportinalen Dreisatz und neuer Pixelanzahlen die jeweilige Entfernung berechnen
  abstandK1 = 200*127/abstandHS1;
  abstandK2 = 200*127/abstandHS2;
  //abstandK3 = 200*127/abstandHS3;
  
  
  
  /*Ausgabe des Abstand zur Kamera
  console.log ('Abstand zur Kamera P1: '+abstandK1);
  console.log ('Abstand zur Kamera P2: '+abstandK2);
  console.log ('Abstand zur Kamera P3: '+abstandK3);*/
  
  if (schulterLX1 < schulterLX2) { 
    // Man muss unterscheiden ob Person 1 links im Bildschirmsteht oder rechts 
    
    //Abstand zwischen Mitte der beiden Schultern und dem Bildschirmrand berechnen
  abstandD = ( schulterLX1 + schulterRX1 )* 0,5;
  abstandF = 1000- ( schulterLX2 + schulterRX2 )* 0,5; 
  } else {  
  
     //Abstand zwischen Mitte der beiden Schultern und dem Bildschirmrand berechnen
  abstandD = ( schulterLX2 + schulterRX2 )* 0,5;
  abstandF = 1000- ( schulterLX1 + schulterRX1 )* 0,5; 
  }
  
  
  abstandE = abstandF - abstandD; //Abstand zwischen Person 1 und 2 in Pixel in X Ebene

  //Abstände zwischen Personen 1 und Kamera und Person 2 und Kamera in Pixel
  abstand1 = sqrt(c*c + abstandD*abstandD - 2*abstandD*c*0,5);
  abstand2 = sqrt(c*c + abstandF*abstandF - 2*abstandF*c*0,5); 
  
  //Winkel zwischen Person 1 und 2 
  winkel12 = 
  (abstand1*abstand1 + abstand2*abstand2 - abstandE*abstandE)/(2*abstand1*abstand2 );
  
  
  //Berechnen des Abstands zwischen den Personen mit Hilfe des Kosinussatzes
  abstandFinal12 = sqrt(pow(abstandK1,2)+pow(abstandK2,2)-2*abstandK1*abstandK2*winkel12);
  
  //abstandFinal13 = sqrt(pow(abstandK1,2)+pow(abstandK3,2)-2*abstandK1*abstandK3*cos();
  
  //abstandFinal23 = sqrt(pow(abstandK3,2)+pow(abstandK2,2)-2*abstandK3*abstandK2*cos();
  
  
  
  //Ausgabe des Abstands zwischen den zwei Personen
  console.log ('Der Abstand zwischen den zwei Personen12: '+abstandFinal12);
  
  //console.log ('Der Abstand zwischen den zwei Personen13: '+abstandFinal13);
  
  //console.log ('Der Abstand zwischen den zwei Personen23: '+abstandFinal23);
  
  }
   
  
  

 var distance = 42; // der Wert, den man an den Server schickt
    var xhttp = new XMLHttpRequest();
    xhttp.open("POST", '/dist', true); 
    //Den richtigen POST-Request-Header schicken:
    xhttp.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
 
    xhttp.onreadystatechange = function() { // Diese Funktion wird aufgerufen, sobald der Zustand sich aendert
        if (this.readyState === XMLHttpRequest.DONE && this.status === 200) {
            // Request ausgefuehrt. Weitere Aktionen koennen ausgefuehrt werden.
        }
    }
    xhttp.send("distance=" + distance); // den Wert als Eigenschaft distance schicken
 
  
}

function modelReady(){
  console.log('model ready');
}

function draw() {
  image(video,0,0);
  fill (255,0,0);
}
